//
//  DaoFactory.swift
//  IngDao
//
//  Created by Gan Yew on 19/10/2020.
//  Copyright © 2020 Gan Yew. All rights reserved.
//

import UIKit

public class DaoFactory: NSObject {
    
    public static let shared = DaoFactory()
    var adapter: DaoAdapter!
    
    public func startInit(adapter: DaoAdapter, callback: ((Error?) -> Void)? ) {
        self.adapter = adapter
        self.adapter.startInit(callback)
    }
    
    public func fetchFor(_ key: String, query: String, params: Dictionary<String, Any>, callback: (([Any]?,Error?) -> Void)?) {
        self.adapter.fetchFor(key, query: query, params: params, callback: callback)
    }
    
    func saveFor(_ key: String, params: Dictionary<String, Any>, callback: ((Any?,Error?) -> Void)?)
    
    func deleteFor(_ key: String, params: Dictionary<String, Any>, callback: ((Any?,Error?) -> Void)?)

}
