import 'package:ingdao/dataflow/entity/dfbaseentity.dart';
import 'package:ingdao/dataflow/entity/dfdbentity.dart';
import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/field/dfdbfield.dart';
import 'entrole.dart';
import 'userfield.dart';

class User extends DfDbEntity with UserField {
    
  User ({String id, String password, String name, String email, String roleid, String picture}) : super(name: "appuser") {
    fId = DfDbField(entity: this, name: "id", primaryKey: true, joinKey: false, type: FieldType.text, value: id);
    fPassword = DfDbField(entity: this, name: "password", primaryKey: false, joinKey: false, type: FieldType.text, value: password);
    fName = DfDbField(entity: this, name: "name", primaryKey: false, joinKey: false, type: FieldType.text, value: name);
    fEmail = DfDbField(entity: this, name: "email", primaryKey: false, joinKey: false, type: FieldType.text, value: email);
    fRoleid = DfDbField(entity: this, name: "roleid", primaryKey: false, joinKey: true, type: FieldType.text, value: roleid);
    fPicture = DfDbField(entity: this, name: "picture", primaryKey: false, joinKey: false, type: FieldType.text, value: picture);    
    fRoleName = DfDbField(entity: Role(), name: "name", primaryKey: false, joinKey: false, type: FieldType.text, displayOnly: true);
  }

  //Define the sqilite table fields available.
  //Define the fields will map back to the sqlite query executed reuslt: Map<String,dynamic>
  @override
  List<DfDbField> fields() {
     return [fId,fPassword,fName,fEmail,fRoleid,fPicture,fRoleName];
  }

  @override
  DfBaseEntity<DfBaseField> newInstance() {
    return User();
  }
}