import 'package:ingdao/dataflow/control/dfquery.dart';
import 'package:ingdao/dataflow/control/dfqueryorderby.dart';
import 'package:ingdao/dataflow/entity/dfbaseentity.dart';
import 'package:ingdao/dataflow/entity/dfwebentity.dart';
import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/field/dfwebfield.dart';
import 'entroleweb.dart';
import 'userfield.dart';

class UserWeb extends DfWebEntity with UserField {
  //User({this.id,this.password,this.name,this.email,this.roleid}); 
  UserWeb ({String id, String password, String name, String email, String roleid, String picture}) : super(contextPath: "user") {
    //{@required DfBaseEntity entity, @required String name, @required this.primaryKey, @required this.joinKey, @required this.type, dynamic value}
    fId = DfWebField(entity: this, name: "id", value: id);
    fPassword = DfWebField(entity: this, name: "password", value: password);
    fName = DfWebField(entity: this, name: "name", value: name);
    fEmail = DfWebField(entity: this, name: "email", value: email);
    fRoleid = DfWebField(entity: this, name: "roleid", value: roleid);
    fPicture = DfWebField(entity: this, name: "picture", value: picture);
    fRoleName = DfWebField(entity: RoleWeb(), name: "rolename");    
  }

  //Define what are the fields will map back the result from http response Map<String,dynamic>
  @override
  List<DfWebField> fields() {
     return [fId,fPassword,fName,fEmail,fRoleid,fPicture,fRoleName];
  }

  @override
  DfWebReqParam convertToWebReqParam(DfQuery query) {
    if (query.purpose == DfQueryPurpose.FETCH) {
      DfWebReqParam param = DfWebReqParam();
        param.reqParams["pageNumber"] = "${query.paging.pageNumber}";
        param.reqParams["perPageCount"] = "${query.paging.perPageCount}";

        int i = 0;
        for (var orderBy in query.orderBy) {
          ++i;
          param.reqParams["orderBy$i"] = orderBy.field.name;
          param.reqParams["asc$i"] = orderBy.orderByType ==OrderByType.asc ? "true" : "false";
        }

        if (query.criteriaGroup != null) {
          for (var cri in query.criteriaGroup.criterias) {
            param.reqParams[cri.field.name] = cri.values[0];
          }
        }

        return param;
    }
    return null;
  }

  @override
  DfBaseEntity<DfBaseField> newInstance() {
    return UserWeb();
  }
}