import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/repository/dfbaserepository.dart';
import '../../../appsetting.dart';
import 'entuser.dart';
import 'entuserweb.dart';

abstract class UserField {

  DfBaseField fId;
  DfBaseField fPassword;
  DfBaseField fName;
  DfBaseField fEmail;
  DfBaseField fRoleid;
  DfBaseField fPicture;
  DfBaseField fRoleName;

  static UserField createUserFieldBasedOnRepo(DfBaseRepository repo) {
    switch (repo.model.name) {
      case REPO_NAME_SQLITEDB :
        return User();
      case REPO_NAME_WEB :
        return UserWeb();
    }
    return null;
  }
}