import 'package:meta/meta.dart';
import 'dfquerycriteria.dart';

enum AndOrType {
  and,
  or
}

extension AndOrTypeExtension on AndOrType {

  String get name {
    switch (this) {
      case AndOrType.and:
        return 'and';
      case AndOrType.or:
        return 'or';
      default:
        return null;
    }
  }
}

class DfQueryCriteriaGroup {

  List<DfQueryCriteria> criterias;
  AndOrType andOrType;

  DfQueryCriteriaGroup({@required this.criterias, this.andOrType = AndOrType.and});

  String toGroupStr() {
    if (criterias == null || criterias.length == 0) {
      return '';
    }

    String result = "";
    criterias.forEach((item) {
      if (result.length > 0) {
        String andOrName = andOrType.name;        
        result = "$result $andOrName ";
      }
      String criStr = item.toCriteriaStr();
      result = "$result$criStr";
    });
    if (result.length > 0)
      return '(' + result + ')';
    else
      return '';
  }

}