import 'package:meta/meta.dart';
import '../field/dfbasefield.dart';
import '../field/dfdbfield.dart';

enum OrderByType {
  asc,
  desc
}

extension OrderByTypeExtension on OrderByType {

  String get name {
    switch (this) {
      case OrderByType.asc:
        return 'asc';
      case OrderByType.desc:
        return 'desc';
      default:
        return null;
    }
  }

  String desp() {
    return this.name;
  }
}

class DfQueryOrderBy {

  DfBaseField field;
  OrderByType orderByType;

  DfQueryOrderBy({@required this.field, this.orderByType = OrderByType.asc});

  String toOrderByStr() {
    if (field is DfDbField) {
      DfDbField dbF = field;
      return "${dbF.getSelectQueryAlias()} ${orderByType.name}";
    }
    else {
      return "${field.name} ${orderByType.name}";      
    }

  }
}