import 'dart:convert';
import 'package:meta/meta.dart';
import 'package:nui_web/nui_web_models.dart';
import 'package:http/http.dart' as http;

class DfError implements Exception {
  int code;
  String message;

  DfError({@required this.code, @required this.message});

  String errMsg() => message; 
}

class DfResponse {
  DfError error;
  List<Map<String,dynamic>> result;
  int fetchCountData;

  DfResponse({this.error,this.result,this.fetchCountData});

  void dataFromPlainHttpResponse(http.Response resp) {
    if (resp.body != null) {
      result = List<Map<String,dynamic>>();
      String tStr = resp.body.trim();
      if (tStr.startsWith("[")) {
        List data = jsonDecode(tStr);

        result = List<Map<String,dynamic>>();
        for (Map<String,dynamic> item in data) {
          result.add(item);
        }
      }
      else {
        result.add(jsonDecode(tStr));
      }
    }
    return;
  }

  void dataFromHttpResponse(NUIHttpResponse resp) {
    if (resp.getErrorAsEnt() != null) {
      error = DfError(code: resp.getErrorAsEnt().status, message: resp.getErrorAsEnt().error);
    }

    if (resp.response != null) {
      result = List<Map<String,dynamic>>();
      String tStr = resp.response.trim();
      if (tStr.startsWith("[")) {
        List data = jsonDecode(tStr);
        for (Map<String,dynamic> item in data) {
          result.add(item);
        }
      }
      else {
        result.add(jsonDecode(tStr));
      }
    }
    return;
  }
}