import 'package:meta/meta.dart';
import '../field/dfbasefield.dart';

abstract class DfBaseEntity<T extends DfBaseField> {

  String name;
  List<T> fields();

  DfBaseEntity({@required this.name});

  fromMap(Map<String,dynamic> dict) {
    fields().forEach((field) => field.setValueFromQueryResult(dict));
  }

  Map<DfBaseField, dynamic> toMap() {
    Map<DfBaseField,dynamic> result = Map<DfBaseField,dynamic>();
    fields().where((field) => field.displayOnly == null || !field.displayOnly).forEach((field) => result[field] = field.value);
    return result;
  }

  DfBaseField getSelectQueryCountField();

  DfBaseEntity newInstance();
}