import 'package:meta/meta.dart';
import 'dfbasefield.dart';
import '../entity/dfbaseentity.dart';

enum FieldType {
  text,
  integer,
  real,
  blob
}

extension FieldTypeExtension on FieldType {

  String get name {
    switch (this) {
      case FieldType.text:
        return 'TEXT';
      case FieldType.integer:
        return 'INTEGER';
     case FieldType.real:
        return 'REAL';
     case FieldType.blob:
        return 'BLOB';                
      default:
        return null;
    }
  }

  String desp() {
    return this.name;
  }
}

class DfDbField extends DfBaseField {

  bool primaryKey;
  bool joinKey;
  FieldType type;
  bool displayOnly;

  DfDbField({@required DfBaseEntity entity, @required String name, @required this.primaryKey, @required this.joinKey, @required this.type, this.displayOnly, dynamic value}) : super(entity: entity, name: name, displayOnly: displayOnly, value: value);

     String toCreateFieldStr() {
     String typeStr = type.name;
     return "$name $typeStr";
   }

   String getSelectQueryField() {
     if (name.toLowerCase().indexOf("count(") >= 0) {
       return "count(*) as ${entity.name}_count";
     }
     return "${entity.name}.$name as ${entity.name}_$name";
   }

   String getSelectQueryAlias() {
     return "${entity.name}_$name";
   }

   setValueFromQueryResult(Map<String,dynamic> dict) {
    value = dict[getSelectQueryAlias()];
   }

}