import 'package:meta/meta.dart';
import 'dfbasemodel.dart';
import '../entity/dfwebentity.dart';

enum SslPinningCriShaType {
  SHA1,
  SHA256
}

class SslPinningCri {
  List<String> shakeys;
  SslPinningCriShaType shatype;

  SslPinningCri({this.shakeys, this.shatype});
}

class DfWebModel extends DfBaseModel<DfWebEntity> {
  String serverUrl;
  Map<String,String> commonHeaders;
  SslPinningCri sslPinningCri;

  DfWebModel({@required String name, @required bool encrypt, @required this.serverUrl, @required List<DfWebEntity> entities, this.commonHeaders, this.sslPinningCri}) : super(name: name, encrypt: encrypt, entities: entities);

  static Map<String,String> formJsonHeader({String authToken}) {
    Map<String,String> headers = Map<String,String>();

    headers["Content-Type"] = "application/json";
    headers["Accept"] = "application/json";

    if (authToken != null)
      headers["authorization"] = "Bearer $authToken";
    return headers;  
  }

}